<?php

	class wialon {
		public $ssid = "";
		public $dns = "kit-api.wialon.com";
		public $file_log = "/logs/wialon_kit.log";
		public $debug_mode = "1";
		
		function __construct() {
				
		}
		
		// login
		function login($login,$pass) 
		{	
			$result_login = $this->wialon_request("core/login","{\"user\":\"" . $login . "\", \"password\":\"" . $pass . "\"}");
			$this->ssid = $result_login -> {'eid'};
			$this->sk_trace("Login to wialon (ssid: " . $this->ssid . ")");
		}
		// logout
		function logout() 
		{
			if ($this->ssid == "")
				return "error";
				
			$this->sk_trace("Logout wialon (ssid: " . $this->ssid . ")");
			$this->wialon_request("core/logout","{}");
			$this->ssid = "";
		}
		
		// check sid
		function check_sid() 
		{
			return $this->wialon_request("core/get_hw_types","{}");
		}
		
		// request to wialon with socket
		function wialon_request($svc,$params,$now_decode=0) 
		{
			$fp = fsockopen($this->dns, 80, $errno, $errstr, 60);
			if (!$fp) {
				$this -> sk_trace("error wialon_request: $errstr ($errno)");
				return;
			} 
			
			if ($this->ssid != "")
				$data = "svc=" . $svc . "&sid=" . $this->ssid . "&params=" . $params . "\r\n";
			else 
				$data = "svc=" . $svc . "&params=" . $params . "\r\n";
			
			if ($this->debug_mode == "1") {
				$this->sk_trace("request: " . $data);
			}
			
			$out = "POST /wialon/ajax.html HTTP/1.0\r\n";
			$out .= "Host: " . $this->dns . "\r\n";
			$out .= "Content-type: application/x-www-form-urlencoded\r\n";
			$out .= "Content-length: ".strlen($data)."\r\n";
			$out .= "Connection: Close\r\n\r\n";
			$out .= $data."\r\n\r\n";
			
			$html = '';
			
			fwrite($fp, $out);
			while (!feof($fp)) {
				$html .= fgets($fp, 128);
			}
			fclose($fp);
			
			$pos = strpos($html, "\r\n\r\n");
			if ($pos > 0) {
				$html = substr($html, $pos+4);
			}

			if ($this->debug_mode == "1") {
				$this->sk_trace("answer: " . $html);
			}
			if ($now_decode == 1) 
				$json = $html;
			else {
				$json = json_decode($html);
				if ($json->{'error'} != "") {
					$this->sk_trace("Errro request to Wialon (ssid: " . $this->ssid . ") : " . $html);
					return "error";
				}
			}
			return $json;
		}
		// function show message to log file
		function sk_trace($str) 
		{
			$date = date("Y/m/d H:i:s:");			
			$file = fopen($_SERVER["DOCUMENT_ROOT"] . $this->file_log, "a+");
			if (!$file) {
				return;
			}
			fwrite($file, "$date $str \r\n"); 
			fclose($file); 
		}
		
		// get units array
		function get_items($type,$flags)
		{
			if ($this->debug_mode == "1") {
				$this->sk_trace("start function get units");
			}
		
			$params = '{"spec":{"itemsType":"' . $type . '","propName":"sys_name","propValueMask":"*","sortType":"sys_name"},"force":1,"flags":' . $flags . ',"from":0,"to":"0xffffffff"}';
			$items = $this->wialon_request("core/search_items",$params);
			
			return $items -> {'items'};
		}
		
		// serach items from id
		function search_items_from_id($items,$id)
		{
			if($items != "")
			foreach($items as $item) {
				$name_item = $item->{'nm'};
				$id_item = $item->{'uid'};
				
				if ($this->debug_mode == "1") 
					$this->sk_trace("items id $id_item , name $name_item");
				
				if ($id_item == $id) 
					return $item;
				
			}
			return "";
		}
		
		// serach report from name
		function search_report_from_name($name)
		{
			$params = '{"spec":[{ "type":"type","data":"avl_resource","flags": "0x2001","mode":0 }]}';
			$resources = $this->wialon_request("core/update_data_flags",$params);
			foreach($resources as $resource) {
				$reports = $resource->{'d'}->{'rep'};
				if ($reports == "")
					continue;
				foreach($reports as $report) {
					if ($this->debug_mode == "1") 
						$this->sk_trace("reoprt name " . $report->{'n'});
										
					if ($report->{'n'} == $name)
						return Array("res_id" => $resource->{'i'},"templ_id" => $report->{'id'});					
				}
			}
			
			return "";
		}
		
		function format_interval($seconds){
			$days = floor($seconds/86400);
			$seconds = $seconds-($days*86400);
			$hours = floor($seconds/3600);
			$seconds = $seconds-($hours*3600);
			$minutes = floor($seconds/60);
			$seconds = $seconds-($minutes*60);
			
			$res = "";
			if ($days > 0) {
				$res = $days . "дн " . $hours . "ч " .  $minutes . "м " . $seconds . "c";
			} else if ($hours > 0) {
				$res = $hours . "ч " .  $minutes . "м " . $seconds . "c";
			} else if ($minutes > 0) {
				$res = $minutes . "м " . $seconds . "c";
			} else {
				$res = $seconds . "c";
			}
			
			return $res;
		}
		
	} 

?>