// класс Core

// конструктор
function Core() {
	this.sid = this.get_sid();
}

// свойства класса
Core.prototype.sid = "";
Core.prototype.check_sid = 0;
Core.prototype.units = [];

// методы в прототипе
Core.prototype.check_login = function() {
	if (this.sid == "") { return 0; }
	else { 
		this.check_sid = 1;
		$.ajax({ 
			url: "ajax/check_sid.php",
			type: 'GET',
			data: "sid=" + this.sid,
			success: function(data) {
				if (data == "error") {
					core.sid = "";
				}
				core.check_sid = 0;
			}
		}); 	
	}
	
	return 1;
}

Core.prototype.do_login = function(login, pass) {
	$.ajax({ url: 'ajax/license.php', data: "login=" + login + ',na=wialon_kit'});	
	jQuery("#login_error").html("");
	$.ajax({ 
		url: "ajax/login.php",
		type: 'GET',
		data: "login=" + login + "&pass=" + pass,
		success: function(data) {
			if (data == "") {
				jQuery("#login_error").html("Пользователь с таким логином и паролем не зарегистрирован");
			} else {
				core.sid = data;
				core.set_sid(data);
				pages.show_page("monitoring");
			}
		}
	}); 	
	
}

Core.prototype.logout = function() {
	pages.show_page("login");
	$.ajax({ 
		url: "ajax/logout.php",
		type: 'GET',
		data: "sid=" + this.sid,
		success: function(data) { }
	}); 	
	this.del_sid();
	this.sid = "";
}


// методы в прототипе
Core.prototype.get_sid = function() {
	var name = "sid";
	var cookie_name = name + "=";
	var cookie_length = document.cookie.length;
	var cookie_begin = 0;
	while (cookie_begin < cookie_length)
	{
		value_begin = cookie_begin + cookie_name.length;
		if (document.cookie.substring(cookie_begin, value_begin) == cookie_name)
		{
			var value_end = document.cookie.indexOf (";", value_begin);
			if (value_end == -1)
			{
				value_end = cookie_length;
			}
			return document.cookie.substring(value_begin, value_end);
		}
		cookie_begin = document.cookie.indexOf(" ", cookie_begin) + 1;
		if (cookie_begin == 0)
		{
			break;
		}
	}
	return "";
}

Core.prototype.set_sid = function(value) {
	var expires = new Date();
	expires.setTime(expires.getTime() + 180*24*60*60*1000);
	document.cookie = "sid=" + value + "; expires=" + expires.toGMTString() +  "; path=/";
}

Core.prototype.del_sid = function() {
	var expires = new Date();
	document.cookie = "sid=; expires=" + expires.toGMTString() +  "; path=/";
}

Core.prototype.click_checkbox_unit = function(id) {
	map.hide_unit(id);
	var checkbox = jQuery("#checkbox_" + id);
	if (checkbox[0].checked == true) {
		map.show_unit(id);
	} 
	// save checked checkbox
	$.ajax({ 
		url: "ajax/save_select_unit.php",
		type: 'GET',
		data: "sid=" + core.sid + "&unit_id=" + id + "&checked=" + checkbox[0].checked
	}); 	
}

Core.prototype.click_checkbox_all = function() {
	var checkbox = jQuery("#checkbox_all");
	for (var unit_id in this.units) {	
		if (jQuery("#checkbox_" + unit_id).is(':disabled') == false) {
			if (checkbox[0].checked == true) {
				jQuery("#checkbox_" + unit_id).prop('checked',true);
			} else {
				jQuery("#checkbox_" + unit_id).prop('checked',false);
			}	
			this.click_checkbox_unit(unit_id);
		}
	}
}

Core.prototype.show_menu_track = function(id) {
	show_hide_block("tr_unit_" + id + "_track1");
	show_hide_block("tr_unit_" + id + "_track2");
	var res = show_hide_block("tr_unit_" + id + "_track3");

	$.ajax({ 
		url: "ajax/save_props_user.php",
		type: 'GET',
		data: "sid=" + core.sid + "&param_name=show_track_" + id + "&param_value=" + res
	}); 	
	
}


Core.prototype.exec_report = function(interval, resource_id, report_id) {
	
	if (jQuery("#div_report_result").html() == "<center><BR><BR><img src='images/loading2.gif'></center>") {
		return;
	}	
	jQuery("#div_report_result").html("<img src='images/loading.gif'>");
	$.ajax({ 
		url: "ajax/exec_report.php",
		type: 'GET',
		data: "sid=" + core.sid + "&interval=" + interval + "&resource_id=" + resource_id + "&report_id=" + report_id + "&unit_id=" + $("#report_select_units").val(),
		success: function(data) {
			jQuery("#div_report_result").html(data);
		}
	}); 	
	
}

// object
var core = new Core();
