// класс Map

// конструктор
function Map() {

}

// свойства класса
Map.prototype.map_obj = "";
Map.prototype.markersArray = [];	
Map.prototype.unitsLayer = "";	
Map.prototype.trackPointsLayer = "";
Map.prototype.trackLayer = "";	
Map.prototype.track_array = [];

// методы в прототипе
Map.prototype.show_map = function(id_div) {	
	
	//Отображаться карта будет в проекции EPSG:4326. 
	var options = {
	   projection: new OpenLayers.Projection("EPSG:900913"),
	   displayProjection: new OpenLayers.Projection("EPSG:4326"),
	};
	
	this.map_obj = new OpenLayers.Map(id_div, options);
	
	// Создаем слои-карты OpenStreet 
	var mapnik = new OpenLayers.Layer.OSM();
	
	var gphy = new OpenLayers.Layer.Google(
	    "Google Physical",
	    {type: google.maps.MapTypeId.TERRAIN}
	    // used to be {type: G_PHYSICAL_MAP}
	);
	var gmap = new OpenLayers.Layer.Google(
	    "Google Streets", // the default
	    {numZoomLevels: 20}
	    // default type, no change needed here
	);
	var ghyb = new OpenLayers.Layer.Google(
	    "Google Hybrid",
	    {type: google.maps.MapTypeId.HYBRID, numZoomLevels: 20}
	    // used to be {type: G_HYBRID_MAP, numZoomLevels: 20}
	);
	var gsat = new OpenLayers.Layer.Google(
	    "Google Satellite",
	    {type: google.maps.MapTypeId.SATELLITE, numZoomLevels: 22}
	    // used to be {type: G_SATELLITE_MAP, numZoomLevels: 22}
	);

	this.map_obj.addLayers([gmap,gphy,ghyb,gsat,mapnik]);
	this.map_obj.addControl(new OpenLayers.Control.LayerSwitcher());
	this.map_obj.zoomToMaxExtent();
	
	var point0 = new OpenLayers.Geometry.Point(37.600328, 55.692624);
	point0.transform(new OpenLayers.Projection("EPSG:4326"), new OpenLayers.Projection("EPSG:900913"));
	this.map_obj.setCenter(new OpenLayers.LonLat(point0.x, point0.y), 10);
	
	this.unitsLayer = new OpenLayers.Layer.Markers("Units");
	this.unitsLayer.setVisibility(true);
	this.map_obj.addLayer(this.unitsLayer);
	
	this.trackPointsLayer = new OpenLayers.Layer.Markers("TrackPoints");
	this.trackPointsLayer.setVisibility(true);
	this.map_obj.addLayer(this.trackPointsLayer);
		
	this.trackLayer = new OpenLayers.Layer.Vector("Track"); 
	this.map_obj.addLayer(this.trackLayer);      
}

// методы в прототипе
Map.prototype.show_unit = function(id) {
	this.hide_unit(id);
	var iconSize =  new OpenLayers.Size(32,32);
	var iconOffset = new OpenLayers.Pixel(-(iconSize.w/2), -(iconSize.h/2));
	var pos = new OpenLayers.LonLat(core.units[id].x,core.units[id].y).transform(new OpenLayers.Projection("EPSG:4326"),this.map_obj.getProjectionObject());
	if (!pos)
		return;
	
	var marker = new OpenLayers.Marker.Label(pos, new OpenLayers.Icon("images/icon_unit.png", iconSize, iconOffset),"<nobr>" + core.units[id].name + "</nobr>");
	// marker.events.register('mousedown', marker, function(evt) { alert("123"); OpenLayers.Event.stop(evt); });
	this.unitsLayer.addMarker(marker);
	this.markersArray[id] = marker;	
}

// методы в прототипе
Map.prototype.hide_unit = function(id) {	
	if (this.markersArray[id] != "" && typeof this.markersArray[id] != 'undefined')
		this.unitsLayer.removeMarker(this.markersArray[id]);
	// this.markersArray[id].destroy();
}

// методы в прототипе
Map.prototype.go_to_unit = function(id) {	
	var pos = new OpenLayers.LonLat(core.units[id].x,core.units[id].y).transform(new OpenLayers.Projection("EPSG:4326"),this.map_obj.getProjectionObject());
	if (pos)
		this.map_obj.panTo(pos);     
}

// методы в прототипе
Map.prototype.show_track = function(unit_id, interval) {	
	
	$("#td_track_" + unit_id).html("<img src='images/mini_loading.gif'>");
	
	$.ajax({ 
		url: "ajax/get_track.php",
		type: 'GET',
		data: "sid=" + core.sid + "&interval=" + interval + "&unit_id=" + unit_id,
		success: function(data) {
			if (data == "") {
				alert("Данные для построения трека отсутствуют.");
				$("#td_track_" + unit_id).html("<img src='images/icon_track.png'>");
				return;
			}
			$("#td_track_" + unit_id).html("<img src='images/icon_track.png'>");
			map.track_array = jQuery.parseJSON(data);
			map.show_track_to_map();
			// map.go_to_unit(unit_id);
		}
	}); 	
}


Map.prototype.show_track_to_map = function() {
	
	this.trackLayer.removeAllFeatures();
//	this.trackPointsLayer.clearMarkers();
	
	var bounds = new OpenLayers.Bounds();

	var iconSize =  new OpenLayers.Size(20,29);
	var iconOffset = new OpenLayers.Pixel(-(iconSize.w/2), -(iconSize.h));
	var points = new Array();
	var hag = this.track_array.length/10;
	for (var i = 0; i < this.track_array.length; i++) {
		var msg = this.track_array[i];			
		if (msg == "")
			continue;
		var pos = new OpenLayers.Geometry.Point(msg.x,msg.y).transform(new OpenLayers.Projection("EPSG:4326"), this.map_obj.getProjectionObject());
		var pos_marker = new OpenLayers.LonLat(msg.x,msg.y).transform(new OpenLayers.Projection("EPSG:4326"),this.map_obj.getProjectionObject());
		points[i] = pos;
		if (i > hag) {
			var marker = new OpenLayers.Marker.Label(pos_marker, new OpenLayers.Icon("images/icon_point.png", iconSize, iconOffset),"<nobr>" + msg.time + "</nobr>");
			this.trackPointsLayer.addMarker(marker);
			bounds.extend(pos_marker);
			hag = hag + this.track_array.length/10;
		}
	}
	
	var line = new OpenLayers.Geometry.LineString(points);
	var style = { 
	  strokeColor: '#0000ff', 
	  strokeOpacity: 0.5,
	  strokeWidth: 5
	};
	var lineFeature = new OpenLayers.Feature.Vector(line, null, style);
	this.trackLayer.addFeatures([lineFeature]);
	this.map_obj.zoomToExtent(bounds);
	this.track_array.length = 0;
}

// object
var map = new Map("");
